!
!     ======( PHYSICAL CONSTANTS )======
!
!        PI    : PI
!        AEE   : ELEMENTATY CHARGE
!        AME   : ELECTRON MASS
!        AMP   : PROTON MASS
!        VC    : SPEED OF LIGHT IN VACUUM
!        RMU0  : PERMEABILITY OF FREE SPACE
!        EPS0  : PERMITTIVITY OF FREE SPACE
!        CI    : IMAGINARY UNIT
!
MODULE PLCNS1
  REAL(8),     PARAMETER :: PI   = 3.14159265358979323846D0
  REAL(8),     PARAMETER :: AEE  = 1.6021892D-19
  REAL(8),     PARAMETER :: AME  = 9.109534D-31
  REAL(8),     PARAMETER :: AMP  = 1.6726485D-27
  REAL(8),     PARAMETER :: VC   = 2.99792458D8
  REAL(8),     PARAMETER :: RMU0 = 4.D0*PI*1.D-7
  REAL(8),     PARAMETER :: EPS0 = 1.D0/(VC*VC*RMU0)
  COMPLEX(8),  PARAMETER :: CI   = (0.D0,1.D0)
END MODULE
